﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Simple_Bible_Reader
{
    public class Win32NativeCalls
    {
        [FlagsAttribute]
        public enum EXECUTION_STATE : uint
        {
            ES_AWAYMODE_REQUIRED = 0x00000040,
            ES_CONTINUOUS = 0x80000000,
            ES_DISPLAY_REQUIRED = 0x00000002,
            ES_SYSTEM_REQUIRED = 0x00000001
        }

        [DllImport("kernel32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        static extern EXECUTION_STATE SetThreadExecutionState(EXECUTION_STATE esFlags);

        // Adpated from https://stackoverflow.com/questions/38282770/stop-screensaver-programmatically

        public static void preventScreensaver()
        {
            // To stop screen saver and monitor power off event
            SetThreadExecutionState(EXECUTION_STATE.ES_DISPLAY_REQUIRED | EXECUTION_STATE.ES_SYSTEM_REQUIRED | EXECUTION_STATE.ES_CONTINUOUS);
        }

        public static void restoreScreensaver()
        {
            //To reset or allow those event again you have to call this API with only ES_CONTINUOUS
            SetThreadExecutionState(EXECUTION_STATE.ES_CONTINUOUS);//This will reset as normal
        }
    }
}
